/*
  repeater-test.cc

  Copyright (C) 2011 Taiji Yamada <taiji@aihara.co.jp>
 */
#include <iostream>
#include <boost/lexical_cast.hpp>
#include "date_time_numeric.hpp"
#include "repeater.hpp"
#include "date_time_repeater.hpp"
using namespace std;
using namespace boost;

int main00()
{
  repeater<int, int> r(4), s(4,1,4), t(4,1,11), u(4,3,4), v(4,3,11);
  string a, b, c, d, e;

  cout << "r: " << r << "\tcount: " << r.count() << "\tlast: " << r.last() << endl; a = lexical_cast<string>(r);
  cout << "s: " << s << "\tcount: " << s.count() << "\tlast: " << s.last() << endl; b = lexical_cast<string>(s);
  cout << "t: " << t << "\tcount: " << t.count() << "\tlast: " << t.last() << endl; c = lexical_cast<string>(t);
  cout << "u: " << u << "\tcount: " << u.count() << "\tlast: " << u.last() << endl; d = lexical_cast<string>(u);
  cout << "v: " << v << "\tcount: " << v.count() << "\tlast: " << v.last() << endl; e = lexical_cast<string>(v);

  r = lexical_cast<repeater<int, int> >(a);	cout << "r: " << r << "\tcount: " << r.count() << "\tlast: " << r.last() << endl; assert(a == lexical_cast<string>(r));
  s = lexical_cast<repeater<int, int> >(b);	cout << "s: " << s << "\tcount: " << s.count() << "\tlast: " << s.last() << endl; assert(b == lexical_cast<string>(s));
  t = lexical_cast<repeater<int, int> >(c);	cout << "t: " << t << "\tcount: " << t.count() << "\tlast: " << t.last() << endl; assert(c == lexical_cast<string>(t));
  u = lexical_cast<repeater<int, int> >(d);	cout << "u: " << u << "\tcount: " << u.count() << "\tlast: " << u.last() << endl; assert(d == lexical_cast<string>(u));
  v = lexical_cast<repeater<int, int> >(e);	cout << "v: " << v << "\tcount: " << v.count() << "\tlast: " << v.last() << endl; assert(e == lexical_cast<string>(v));

  return 0;
}
int main01()
{
  repeater<gregorian::date, gregorian::date_duration> r(gregorian::date(2011, 11, 11));
  repeater<gregorian::date, gregorian::date_duration> s(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 11, 11));
  repeater<gregorian::date, gregorian::date_duration> t(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 12, 11));
  repeater<gregorian::date, gregorian::date_duration> u(gregorian::date(2011, 11, 11), gregorian::date_duration(4), gregorian::date(2011, 11, 11));
  repeater<gregorian::date, gregorian::date_duration> v(gregorian::date(2011, 11, 11), gregorian::date_duration(4), gregorian::date(2011, 12, 11));
  string a, b, c, d, e;

  cout << "r: " << r << "\tcount: " << r.count() << "\tlast: " << r.last() << endl; a = lexical_cast<string>(r);
  cout << "s: " << s << "\tcount: " << s.count() << "\tlast: " << s.last() << endl; b = lexical_cast<string>(s);
  cout << "t: " << t << "\tcount: " << t.count() << "\tlast: " << t.last() << endl; c = lexical_cast<string>(t);
  cout << "u: " << u << "\tcount: " << u.count() << "\tlast: " << u.last() << endl; d = lexical_cast<string>(u);
  cout << "v: " << v << "\tcount: " << v.count() << "\tlast: " << v.last() << endl; e = lexical_cast<string>(v);

  r = lexical_cast<repeater<gregorian::date, gregorian::date_duration> >(a);	cout << "r: " << r << "\tcount: " << r.count() << "\tlast: " << r.last() << endl; assert(a == lexical_cast<string>(r));
  s = lexical_cast<repeater<gregorian::date, gregorian::date_duration> >(b);	cout << "s: " << s << "\tcount: " << s.count() << "\tlast: " << s.last() << endl; assert(b == lexical_cast<string>(s));
  t = lexical_cast<repeater<gregorian::date, gregorian::date_duration> >(c);	cout << "t: " << t << "\tcount: " << t.count() << "\tlast: " << t.last() << endl; assert(c == lexical_cast<string>(t));
  u = lexical_cast<repeater<gregorian::date, gregorian::date_duration> >(d);	cout << "u: " << u << "\tcount: " << u.count() << "\tlast: " << u.last() << endl; assert(d == lexical_cast<string>(u));
  v = lexical_cast<repeater<gregorian::date, gregorian::date_duration> >(e);	cout << "v: " << v << "\tcount: " << v.count() << "\tlast: " << v.last() << endl; assert(e == lexical_cast<string>(v));

  return 0;
}
int main02()
{
  repeater<gregorian::date, gregorian::years> r(gregorian::date(2011, 11, 11));
  repeater<gregorian::date, gregorian::years> s(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2011, 11, 11));
  repeater<gregorian::date, gregorian::years> t(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2031, 12, 11));
  repeater<gregorian::date, gregorian::years> u(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2011, 11, 11));
  repeater<gregorian::date, gregorian::years> v(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2031, 12, 11));
  string a, b, c, d, e;

  cout << "r: " << r << "\tcount: " << r.count() << "\tlast: " << r.last() << endl; a = lexical_cast<string>(r);
  cout << "s: " << s << "\tcount: " << s.count() << "\tlast: " << s.last() << endl; b = lexical_cast<string>(s);
  cout << "t: " << t << "\tcount: " << t.count() << "\tlast: " << t.last() << endl; c = lexical_cast<string>(t);
  cout << "u: " << u << "\tcount: " << u.count() << "\tlast: " << u.last() << endl; d = lexical_cast<string>(u);
  cout << "v: " << v << "\tcount: " << v.count() << "\tlast: " << v.last() << endl; e = lexical_cast<string>(v);

  r = lexical_cast<repeater<gregorian::date, gregorian::years> >(a);	cout << "r: " << r << "\tcount: " << r.count() << "\tlast: " << r.last() << endl; assert(a == lexical_cast<string>(r));
  s = lexical_cast<repeater<gregorian::date, gregorian::years> >(b);	cout << "s: " << s << "\tcount: " << s.count() << "\tlast: " << s.last() << endl; assert(b == lexical_cast<string>(s));
  t = lexical_cast<repeater<gregorian::date, gregorian::years> >(c);	cout << "t: " << t << "\tcount: " << t.count() << "\tlast: " << t.last() << endl; assert(c == lexical_cast<string>(t));
  u = lexical_cast<repeater<gregorian::date, gregorian::years> >(d);	cout << "u: " << u << "\tcount: " << u.count() << "\tlast: " << u.last() << endl; assert(d == lexical_cast<string>(u));
  v = lexical_cast<repeater<gregorian::date, gregorian::years> >(e);	cout << "v: " << v << "\tcount: " << v.count() << "\tlast: " << v.last() << endl; assert(e == lexical_cast<string>(v));

  return 0;
}

int main11()
{
  repeater<gregorian::date, gregorian::date_duration> v, vs[] = {
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(1), gregorian::date(2011, 12, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(5), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::date_duration>(gregorian::date(2011, 11, 11), gregorian::date_duration(5), gregorian::date(2011, 12, 11)),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << endl;
    gregorian::date w, ws[] = { gregorian::date(2011, 11, 5), gregorian::date(2011, 11, 11), gregorian::date(2011, 12, 5), gregorian::date(2011, 12, 11), gregorian::date(2011, 12, 20) };
    for (gregorian::date i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> a = v.after(w);
      cout << (a ? *a : gregorian::date()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> b = v.before(w);
      cout << (b ? *b : gregorian::date()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}
int main12()
{
  repeater<gregorian::date, gregorian::years> v, vs[] = {
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(1), gregorian::date(2031, 12, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2011, 11, 11)),
    repeater<gregorian::date, gregorian::years>(gregorian::date(2011, 11, 11), gregorian::years(4), gregorian::date(2031, 12, 11)),
  };
  for (size_t k=0; k<sizeof(vs)/sizeof(vs[0]); ++k) {
    v = vs[k];
    cout << v << endl;
    gregorian::date w, ws[] = { gregorian::date(2011, 11, 5), gregorian::date(2011, 11, 11), gregorian::date(2011, 12, 5), gregorian::date(2031, 12, 11), gregorian::date(2031, 12, 20) };
    for (gregorian::date i=v.front; v.is_repeat() && !v.is_unlimited() && i<=v.back; i+=v.diff)
      cout << i << endl;
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> a = v.after(w);
      cout << (a ? *a : gregorian::date()) << "\tafter  " << w << endl;   
    }
    for (size_t j=0; j<sizeof(ws)/sizeof(ws[0]); ++j) {
      w = ws[j];
      optional<gregorian::date> b = v.before(w);
      cout << (b ? *b : gregorian::date()) << "\tbefore " << w << endl;
    }
    cout << endl;
  }
  return 0;
}

int main()
{
  main00(); cout << endl;
  main01(); cout << endl;
  main02(); cout << endl;

  main11(); cout << endl;
  main12(); cout << endl;

  return 0;
}
